; CHANGE THIS
alias _tbwin return c:\delphi6\projects\tbwin\tbwin.dll
alias tbwin dll $_tbwin $1-

alias tbmouse {
  var %x = $dll($_tbwin, GetMouse, NOT_USED)
  var %z = x y key hover win
  if ($findtok(%z, $1, 1, 32)) return $gettok(%x, $ifmatch, 32)
  else return $null
}

; stops any current demonstrations in this script
alias tb.stop {
  dll -u $_tbwin
  .timer[tb.lagdemo] off
  .timer[tb.mp3demo] off
  if ($window(@tb.lag)) window -c $ifmatch
  if ($window(@tb.mp3)) window -c $ifmatch
  if ($window(@tb.button)) window -c $ifmatch
  if ($window(@tb.sep)) window -c $ifmatch

  if (!$exists($_tbwin)) {
    echo -s * tbwin_demo.mrc: You must change the path of the DLL first!
    halt
  }
}

on *:load: {
  echo 14 -s * tbwin.dll demo script loaded.
  echo 14 -s $chr(160) $chr(160) Type "/tb.mp3demo" for the mp3 controls demo.
  echo 14 -s $chr(160) $chr(160) Type "/tb.lagdemo" for the lag bar demo.
  echo 14 -s $chr(160) $chr(160) Type "/tb.buttondemo" for the button demo.
  echo 14 -s $chr(160) $chr(160) Type "/tb.stop" to stop any demonstration.
  echo 14 -s $chr(160) $chr(160) NOTE: You must have the Webdings font for the mp3 controls/button demo.
  echo 14 -s $chr(160) $chr(160) NOTE: Make sure to change the path of the DLL in this file!
}
on *:unload: tb.stop

; ###### Lagmeter Demonstration ######
;
; Demonstrates a simple, pseudo-working, lagbar.

alias tb.lagdemo {
  ; Stop any other demos.
  tb.stop

  ; Open our window..
  window -Bph +d @tb.lag 0 0 75 24

  ; Attach it...
  tbwin Attach @tb.lag

  ; Place it in the right spot.
  var %z = $dll($_tbwin, GetTBInfo, NOT_USED)
  var %w = $gettok(%z, 1, 32)
  var %h = $gettok(%z, 2, 32)
  tb.lagsize %w %h

  ; Set the hook to move the window when mIRC is resized.
  tbwin OnSize /tb.lagsize

  ; Set the timer to update it.
  .timer[tb.lagdemo] -o 0 2 tb.lagupdate

  ; Update it now, too.
  tb.lagupdate

  ; Finally, show it.
  window -a @tb.lag
}

alias tb.lagsize window @tb.lag $calc($1 - 80) $int($calc(($2 - 24) / 2)) 75 24

; This alias updates the lag meter... the principle it works on
; is it shows a bar from 0.000 secs to 1.000 secs.  This is
; normally not how lag meters work, but for the sake of the demo,
; we'll do it like this.  You could make yours work like this, or
; you could make it work however you wanted.
alias tb.lagupdate {
  ; Get some "random" lag.
  var %l = $calc($r(1, 1000) / 1000)
  var %t = Lag: %l $+ s

  ; Fill with the face color.  You could optimize here.
  drawrect -nrf @tb.lag $rgb(face) 1 0 0 500 500

  ; Draw the "Lag:" text.
  drawtext -n @tb.lag 1 Tahoma -7 $int($calc((75 - $width(%t, Tahoma, -7)) / 2)) 13 %t

  ; Draw the lag bar with its black outline.
  drawrect -n @tb.lag 1 1 0 2 75 12
  drawrect -nf @tb.lag 4 1 2 4 $int($calc(%l * 71)) 8

  ; Update everything.
  drawdot @tb.lag
}

; ###### mp3 Controls Demostration ######
;
; Adds tiny player controls to your toolbar.

alias tb.mp3demo {
  ; Stop any other demos.
  tb.stop

  ; Open our window...
  window -Bphf +d @tb.mp3 0 0 60 15

  ; Attach it...
  tbwin Attach @tb.mp3

  ; Place it in the right position.
  var %z = $dll($_tbwin, GetTBInfo, NOT_USED)
  var %w = $gettok(%z, 1, 32)
  var %h = $gettok(%z, 2, 32)
  tb.mp3size %w %h

  ; Fill it with face color so it blends.
  drawrect -rf @tb.mp3 $rgb(face) 1 0 0 200 200

  ; Draw all of the buttons.
  tb.mp3button 9 0 0
  tb.mp3button 4 0 15
  tb.mp3button < 0 30
  tb.mp3button : 0 45

  ; Set the mouse event triggers so we can update the buttons.
  tbwin OnMouse mouse /tb.mp3update
  tbwin OnMouse sclick /tb.mp3update
  tbwin OnMouse uclick /tb.mp3update
  tbwin OnMouse leave /tb.mp3update

  ; Set the OnSize trigger so the controls will move.
  ;tbwin OnSize /tb.mp3size

  ; Finally, show the window.
  window -a @tb.mp3
}

alias tb.mp3update {
  ; Get information about the current position of the mouse
  ; and also see if the mouse button is down.
  var %mouse = $dll($_tbwin, GetMouse, NOT_USED)

  var %x = $gettok(%mouse, 1, 32)
  var %y = $gettok(%mouse, 2, 32)
  var %key = $gettok(%mouse, 3, 32)
  var %hover = $gettok(%mouse, 4, 32)
  var %h = $iif(%key & 1, 3, 2)

  ; Update each button accordingly.  Please note that this isn't
  ; nearly the most efficient way to do it.  Normally, you would
  ; only want to update the buttons individually and only when
  ; they need updating.  However, for the sake of the demonstration
  ; we'll do it the easy way here.
  if (%x isnum 0-14) && (%hover) tb.mp3button 9 %h 0
  else tb.mp3button 9 0 0
  if (%x isnum 15-29) && (%hover) tb.mp3button 4 %h 15
  else tb.mp3button 4 0 15
  if (%x isnum 30-44) && (%hover) tb.mp3button < %h 30
  else tb.mp3button < 0 30
  if (%x isnum 45-59) && (%hover) tb.mp3button : %h 45
  else tb.mp3button : 0 45
}

; This alias draws a button at the current X position in the specified
; state.  The syntax is:
;
;   tb.mp3button <character> <state> <x>
;
; The available states are: 1 = normal, 2 = hover, 3 = pressed.

alias tb.mp3button {

  ; Center the "image" of the button in the button.
  var %x = $int($calc((15 - $width($1, Webdings, -10)) / 2))
  var %y = $int($calc((15 - $height($1, Webdings, -10)) / 2))

  ; Get the right edge of the button.  The bottom is always
  ; y=14 and the top is y=0
  var %z = $calc($3 + 14)

  ; If the button is pressed, move the image down and to the
  ; right one pixel to give it a "pushed" look.
  if ($2 == 3) {
    inc %x
    inc %y
  }

  ; Draw the "image" (which is actually just a character from
  ; the Webdings font.
  drawrect -nrf @tb.mp3 $rgb(face) 1 $3 0 15 15
  drawtext -n @tb.mp3 1 Webdings -10 $calc(%x + $3) %y $1

  ; If the button is hover, we need to draw a raised-look button.
  if ($2 == 2) {
    drawline -nr @tb.mp3 $rgb(hilight) 1 $3 14 $3 0 %z 0
    drawline -nr @tb.mp3 $rgb(shadow) 1 $3 14 %z 14 %z 0
  }
  ; If it's pressed, we need to draw an inset-look button.
  elseif ($2 == 3) {
    drawline -nr @tb.mp3 $rgb(shadow) 1 $3 14 $3 0 %z 0
    drawline -nr @tb.mp3 $rgb(hilight) 1 $3 14 %z 14 %z 0
  }

  ; Update everything.
  drawdot @tb.mp3  
}

alias tb.mp3size window @tb.mp3 $calc($1 - 65) $int($calc(($2 - 15) / 2)) 60 15 

; ###### Button Demonstration ######
;
; Adds a rounded toolbar button and separator to the toolbar.

alias tb.buttondemo {
  ; Stop any other demos.
  tb.stop

  ; Open our separator window.
  window -Bphf +d @tb.sep 538 6 2 20

  ; Draw the separator..
  drawline -r @tb.sep $rgb(shadow) 1 0 0 0 20
  drawline -r @tb.sep $rgb(hilight) 1 1 0 1 20

  ; Open our button window!
  window -Bphf +d @tb.button 542 4 25 24

  ; Attach the windows
  tbwin Attach @tb.button
  tbwin Attach @tb.sep

  ; Select the first one..
  tbwin Select @tb.button

  ; Set some mouse events. =]
  tbwin OnMouse enter /tb.buttondraw 2
  tbwin OnMouse leave /tb.buttondraw 1
  tbwin OnMouse sclick /tb.buttondraw 3
  tbwin OnMouse dclick /tb.buttondraw 3
  tbwin OnMouse uclick /tb.uclick

  ; Paint the first one..
  tb.buttondraw 1

  ; Show 'em
  window -a @tb.sep
  window -a @tb.button
}

; This handles the upclick as well as doing additional "stuff"
alias tb.uclick {
  tb.buttondraw 2
  return $input(You clicked the button $+ $chr(44) which did nothing!, 68)
}

; /tb.buttondraw <1|2|3>
;
; 1 = normal
; 2 = hover
; 3 = pressed

alias tb.buttondraw {
  var %top, %bottom

  ; This if/else sets the colors accordingly.  If it's 1, we
  ; want face colors (so there is no border).  Otherwise, we
  ; want an inset or outset, depending on if the mouse is down
  ; or merely hovering.
  if ($1 == 1) {
    %top = $rgb(face)
    %bottom = $rgb(face)
  }
  else {
    %top = $iif($1 == 2, $rgb(hilight), $rgb(shadow))
    %bottom = $iif($1 == 2, $rgb(shadow), $rgb(hilight))
  }

  ; FILL
  drawrect -nrf @tb.button $rgb(face) 1 0 0 25 24

  ; Draw the button.. three round rectangles, 1 to draw the top-left,
  ; one to draw the bottom-right, and one to clean up the middle.
  drawrect -nrd @tb.button %top 1 0 0 23 23 10 10
  drawrect -nrd @tb.button %bottom 1 1 1 23 23 10 10
  drawrect -nrfd @tb.button $rgb(face) 1 1 1 22 22 10 10

  ; Draw the icon thingy.. (yes, I know it's an eye.. couldn't find anything better)
  drawtext -nr @tb.button $rgb(text) Webdings -17 $iif($1 == 3, 2, 1) $iif($1 == 3, 1, 0) N

  ; Update, yo.
  drawdot @tb.button
}
